/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         DBG_STYPE
/* Substitute the variable and function names.  */
#define yyparse         dbg_parse
#define yylex           dbg_lex
#define yyerror         dbg_error
#define yydebug         dbg_debug
#define yynerrs         dbg_nerrs
#define yylval          dbg_lval
#define yychar          dbg_char

/* First part of user prologue.  */
#line 1 "programs/winedbg/dbg.y"

/*
 * Parser for command lines in the Wine debugger
 *
 * Copyright 1993 Eric Youngdale
 * Copyright 1995 Morten Welinder
 * Copyright 2000 Eric Pouech
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "debugger.h"
#include "wine/exception.h"
#include "expr.h"

int dbg_lex(void);
static int dbg_error(const char*);
static void parser(const char*);


#line 116 "programs/winedbg/dbg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef DBG_DEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define DBG_DEBUG 1
#  else
#   define DBG_DEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define DBG_DEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined DBG_DEBUG */
#if DBG_DEBUG
extern int dbg_debug;
#endif

/* Token kinds.  */
#ifndef DBG_TOKENTYPE
# define DBG_TOKENTYPE
  enum dbg_tokentype
  {
    DBG_EMPTY = -2,
    DBG_EOF = 0,                   /* "end of file"  */
    DBG_error = 256,               /* error  */
    DBG_UNDEF = 257,               /* "invalid token"  */
    tCONT = 258,                   /* tCONT  */
    tPASS = 259,                   /* tPASS  */
    tSTEP = 260,                   /* tSTEP  */
    tLIST = 261,                   /* tLIST  */
    tNEXT = 262,                   /* tNEXT  */
    tQUIT = 263,                   /* tQUIT  */
    tHELP = 264,                   /* tHELP  */
    tBACKTRACE = 265,              /* tBACKTRACE  */
    tALL = 266,                    /* tALL  */
    tINFO = 267,                   /* tINFO  */
    tUP = 268,                     /* tUP  */
    tDOWN = 269,                   /* tDOWN  */
    tENABLE = 270,                 /* tENABLE  */
    tDISABLE = 271,                /* tDISABLE  */
    tBREAK = 272,                  /* tBREAK  */
    tHBREAK = 273,                 /* tHBREAK  */
    tWATCH = 274,                  /* tWATCH  */
    tRWATCH = 275,                 /* tRWATCH  */
    tDELETE = 276,                 /* tDELETE  */
    tSET = 277,                    /* tSET  */
    tPRINT = 278,                  /* tPRINT  */
    tEXAM = 279,                   /* tEXAM  */
    tABORT = 280,                  /* tABORT  */
    tECHO = 281,                   /* tECHO  */
    tCLASS = 282,                  /* tCLASS  */
    tMAPS = 283,                   /* tMAPS  */
    tSTACK = 284,                  /* tSTACK  */
    tSEGMENTS = 285,               /* tSEGMENTS  */
    tSYMBOL = 286,                 /* tSYMBOL  */
    tREGS = 287,                   /* tREGS  */
    tALLREGS = 288,                /* tALLREGS  */
    tWND = 289,                    /* tWND  */
    tLOCAL = 290,                  /* tLOCAL  */
    tEXCEPTION = 291,              /* tEXCEPTION  */
    tPROCESS = 292,                /* tPROCESS  */
    tTHREAD = 293,                 /* tTHREAD  */
    tEOL = 294,                    /* tEOL  */
    tEOF = 295,                    /* tEOF  */
    tFRAME = 296,                  /* tFRAME  */
    tSHARE = 297,                  /* tSHARE  */
    tMODULE = 298,                 /* tMODULE  */
    tCOND = 299,                   /* tCOND  */
    tDISPLAY = 300,                /* tDISPLAY  */
    tUNDISPLAY = 301,              /* tUNDISPLAY  */
    tDISASSEMBLE = 302,            /* tDISASSEMBLE  */
    tSTEPI = 303,                  /* tSTEPI  */
    tNEXTI = 304,                  /* tNEXTI  */
    tFINISH = 305,                 /* tFINISH  */
    tSHOW = 306,                   /* tSHOW  */
    tDIR = 307,                    /* tDIR  */
    tWHATIS = 308,                 /* tWHATIS  */
    tSOURCE = 309,                 /* tSOURCE  */
    tPATH = 310,                   /* tPATH  */
    tIDENTIFIER = 311,             /* tIDENTIFIER  */
    tSTRING = 312,                 /* tSTRING  */
    tINTVAR = 313,                 /* tINTVAR  */
    tNUM = 314,                    /* tNUM  */
    tFORMAT = 315,                 /* tFORMAT  */
    tSYMBOLFILE = 316,             /* tSYMBOLFILE  */
    tRUN = 317,                    /* tRUN  */
    tATTACH = 318,                 /* tATTACH  */
    tDETACH = 319,                 /* tDETACH  */
    tKILL = 320,                   /* tKILL  */
    tMAINTENANCE = 321,            /* tMAINTENANCE  */
    tTYPE = 322,                   /* tTYPE  */
    tMINIDUMP = 323,               /* tMINIDUMP  */
    tNOPROCESS = 324,              /* tNOPROCESS  */
    tCHAR = 325,                   /* tCHAR  */
    tSHORT = 326,                  /* tSHORT  */
    tINT = 327,                    /* tINT  */
    tLONG = 328,                   /* tLONG  */
    tFLOAT = 329,                  /* tFLOAT  */
    tDOUBLE = 330,                 /* tDOUBLE  */
    tUNSIGNED = 331,               /* tUNSIGNED  */
    tSIGNED = 332,                 /* tSIGNED  */
    tSTRUCT = 333,                 /* tSTRUCT  */
    tUNION = 334,                  /* tUNION  */
    tENUM = 335,                   /* tENUM  */
    OP_LOR = 336,                  /* OP_LOR  */
    OP_LAND = 337,                 /* OP_LAND  */
    OP_EQ = 338,                   /* OP_EQ  */
    OP_NE = 339,                   /* OP_NE  */
    OP_LE = 340,                   /* OP_LE  */
    OP_GE = 341,                   /* OP_GE  */
    OP_SHL = 342,                  /* OP_SHL  */
    OP_SHR = 343,                  /* OP_SHR  */
    OP_SIGN = 344,                 /* OP_SIGN  */
    OP_DEREF = 345,                /* OP_DEREF  */
    OP_DRF = 346                   /* OP_DRF  */
  };
  typedef enum dbg_tokentype dbg_token_kind_t;
#endif

/* Value type.  */
#if ! defined DBG_STYPE && ! defined DBG_STYPE_IS_DECLARED
union DBG_STYPE
{
#line 41 "programs/winedbg/dbg.y"

    struct dbg_lvalue   lvalue;
    char*               string;
    dbg_lgint_t         integer;
    IMAGEHLP_LINE64     listing;
    struct expr*        expression;
    struct type_expr_t  type;
    struct list_string* strings;

#line 272 "programs/winedbg/dbg.tab.c"

};
typedef union DBG_STYPE DBG_STYPE;
# define DBG_STYPE_IS_TRIVIAL 1
# define DBG_STYPE_IS_DECLARED 1
#endif


extern DBG_STYPE dbg_lval;


int dbg_parse (void);



/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_tCONT = 3,                      /* tCONT  */
  YYSYMBOL_tPASS = 4,                      /* tPASS  */
  YYSYMBOL_tSTEP = 5,                      /* tSTEP  */
  YYSYMBOL_tLIST = 6,                      /* tLIST  */
  YYSYMBOL_tNEXT = 7,                      /* tNEXT  */
  YYSYMBOL_tQUIT = 8,                      /* tQUIT  */
  YYSYMBOL_tHELP = 9,                      /* tHELP  */
  YYSYMBOL_tBACKTRACE = 10,                /* tBACKTRACE  */
  YYSYMBOL_tALL = 11,                      /* tALL  */
  YYSYMBOL_tINFO = 12,                     /* tINFO  */
  YYSYMBOL_tUP = 13,                       /* tUP  */
  YYSYMBOL_tDOWN = 14,                     /* tDOWN  */
  YYSYMBOL_tENABLE = 15,                   /* tENABLE  */
  YYSYMBOL_tDISABLE = 16,                  /* tDISABLE  */
  YYSYMBOL_tBREAK = 17,                    /* tBREAK  */
  YYSYMBOL_tHBREAK = 18,                   /* tHBREAK  */
  YYSYMBOL_tWATCH = 19,                    /* tWATCH  */
  YYSYMBOL_tRWATCH = 20,                   /* tRWATCH  */
  YYSYMBOL_tDELETE = 21,                   /* tDELETE  */
  YYSYMBOL_tSET = 22,                      /* tSET  */
  YYSYMBOL_tPRINT = 23,                    /* tPRINT  */
  YYSYMBOL_tEXAM = 24,                     /* tEXAM  */
  YYSYMBOL_tABORT = 25,                    /* tABORT  */
  YYSYMBOL_tECHO = 26,                     /* tECHO  */
  YYSYMBOL_tCLASS = 27,                    /* tCLASS  */
  YYSYMBOL_tMAPS = 28,                     /* tMAPS  */
  YYSYMBOL_tSTACK = 29,                    /* tSTACK  */
  YYSYMBOL_tSEGMENTS = 30,                 /* tSEGMENTS  */
  YYSYMBOL_tSYMBOL = 31,                   /* tSYMBOL  */
  YYSYMBOL_tREGS = 32,                     /* tREGS  */
  YYSYMBOL_tALLREGS = 33,                  /* tALLREGS  */
  YYSYMBOL_tWND = 34,                      /* tWND  */
  YYSYMBOL_tLOCAL = 35,                    /* tLOCAL  */
  YYSYMBOL_tEXCEPTION = 36,                /* tEXCEPTION  */
  YYSYMBOL_tPROCESS = 37,                  /* tPROCESS  */
  YYSYMBOL_tTHREAD = 38,                   /* tTHREAD  */
  YYSYMBOL_tEOL = 39,                      /* tEOL  */
  YYSYMBOL_tEOF = 40,                      /* tEOF  */
  YYSYMBOL_tFRAME = 41,                    /* tFRAME  */
  YYSYMBOL_tSHARE = 42,                    /* tSHARE  */
  YYSYMBOL_tMODULE = 43,                   /* tMODULE  */
  YYSYMBOL_tCOND = 44,                     /* tCOND  */
  YYSYMBOL_tDISPLAY = 45,                  /* tDISPLAY  */
  YYSYMBOL_tUNDISPLAY = 46,                /* tUNDISPLAY  */
  YYSYMBOL_tDISASSEMBLE = 47,              /* tDISASSEMBLE  */
  YYSYMBOL_tSTEPI = 48,                    /* tSTEPI  */
  YYSYMBOL_tNEXTI = 49,                    /* tNEXTI  */
  YYSYMBOL_tFINISH = 50,                   /* tFINISH  */
  YYSYMBOL_tSHOW = 51,                     /* tSHOW  */
  YYSYMBOL_tDIR = 52,                      /* tDIR  */
  YYSYMBOL_tWHATIS = 53,                   /* tWHATIS  */
  YYSYMBOL_tSOURCE = 54,                   /* tSOURCE  */
  YYSYMBOL_tPATH = 55,                     /* tPATH  */
  YYSYMBOL_tIDENTIFIER = 56,               /* tIDENTIFIER  */
  YYSYMBOL_tSTRING = 57,                   /* tSTRING  */
  YYSYMBOL_tINTVAR = 58,                   /* tINTVAR  */
  YYSYMBOL_tNUM = 59,                      /* tNUM  */
  YYSYMBOL_tFORMAT = 60,                   /* tFORMAT  */
  YYSYMBOL_tSYMBOLFILE = 61,               /* tSYMBOLFILE  */
  YYSYMBOL_tRUN = 62,                      /* tRUN  */
  YYSYMBOL_tATTACH = 63,                   /* tATTACH  */
  YYSYMBOL_tDETACH = 64,                   /* tDETACH  */
  YYSYMBOL_tKILL = 65,                     /* tKILL  */
  YYSYMBOL_tMAINTENANCE = 66,              /* tMAINTENANCE  */
  YYSYMBOL_tTYPE = 67,                     /* tTYPE  */
  YYSYMBOL_tMINIDUMP = 68,                 /* tMINIDUMP  */
  YYSYMBOL_tNOPROCESS = 69,                /* tNOPROCESS  */
  YYSYMBOL_tCHAR = 70,                     /* tCHAR  */
  YYSYMBOL_tSHORT = 71,                    /* tSHORT  */
  YYSYMBOL_tINT = 72,                      /* tINT  */
  YYSYMBOL_tLONG = 73,                     /* tLONG  */
  YYSYMBOL_tFLOAT = 74,                    /* tFLOAT  */
  YYSYMBOL_tDOUBLE = 75,                   /* tDOUBLE  */
  YYSYMBOL_tUNSIGNED = 76,                 /* tUNSIGNED  */
  YYSYMBOL_tSIGNED = 77,                   /* tSIGNED  */
  YYSYMBOL_tSTRUCT = 78,                   /* tSTRUCT  */
  YYSYMBOL_tUNION = 79,                    /* tUNION  */
  YYSYMBOL_tENUM = 80,                     /* tENUM  */
  YYSYMBOL_OP_LOR = 81,                    /* OP_LOR  */
  YYSYMBOL_OP_LAND = 82,                   /* OP_LAND  */
  YYSYMBOL_83_ = 83,                       /* '|'  */
  YYSYMBOL_84_ = 84,                       /* '^'  */
  YYSYMBOL_85_ = 85,                       /* '&'  */
  YYSYMBOL_OP_EQ = 86,                     /* OP_EQ  */
  YYSYMBOL_OP_NE = 87,                     /* OP_NE  */
  YYSYMBOL_88_ = 88,                       /* '<'  */
  YYSYMBOL_89_ = 89,                       /* '>'  */
  YYSYMBOL_OP_LE = 90,                     /* OP_LE  */
  YYSYMBOL_OP_GE = 91,                     /* OP_GE  */
  YYSYMBOL_OP_SHL = 92,                    /* OP_SHL  */
  YYSYMBOL_OP_SHR = 93,                    /* OP_SHR  */
  YYSYMBOL_94_ = 94,                       /* '+'  */
  YYSYMBOL_95_ = 95,                       /* '-'  */
  YYSYMBOL_96_ = 96,                       /* '*'  */
  YYSYMBOL_97_ = 97,                       /* '/'  */
  YYSYMBOL_98_ = 98,                       /* '%'  */
  YYSYMBOL_OP_SIGN = 99,                   /* OP_SIGN  */
  YYSYMBOL_100_ = 100,                     /* '!'  */
  YYSYMBOL_101_ = 101,                     /* '~'  */
  YYSYMBOL_OP_DEREF = 102,                 /* OP_DEREF  */
  YYSYMBOL_103_ = 103,                     /* '.'  */
  YYSYMBOL_104_ = 104,                     /* '['  */
  YYSYMBOL_OP_DRF = 105,                   /* OP_DRF  */
  YYSYMBOL_106_ = 106,                     /* ':'  */
  YYSYMBOL_107_ = 107,                     /* ','  */
  YYSYMBOL_108_ = 108,                     /* '='  */
  YYSYMBOL_109_ = 109,                     /* '('  */
  YYSYMBOL_110_ = 110,                     /* ')'  */
  YYSYMBOL_111_ = 111,                     /* ']'  */
  YYSYMBOL_YYACCEPT = 112,                 /* $accept  */
  YYSYMBOL_input = 113,                    /* input  */
  YYSYMBOL_line = 114,                     /* line  */
  YYSYMBOL_command = 115,                  /* command  */
  YYSYMBOL_pathname = 116,                 /* pathname  */
  YYSYMBOL_identifier = 117,               /* identifier  */
  YYSYMBOL_list_arg = 118,                 /* list_arg  */
  YYSYMBOL_run_command = 119,              /* run_command  */
  YYSYMBOL_list_of_words = 120,            /* list_of_words  */
  YYSYMBOL_list_command = 121,             /* list_command  */
  YYSYMBOL_disassemble_command = 122,      /* disassemble_command  */
  YYSYMBOL_set_command = 123,              /* set_command  */
  YYSYMBOL_x_command = 124,                /* x_command  */
  YYSYMBOL_print_command = 125,            /* print_command  */
  YYSYMBOL_break_command = 126,            /* break_command  */
  YYSYMBOL_watch_command = 127,            /* watch_command  */
  YYSYMBOL_display_command = 128,          /* display_command  */
  YYSYMBOL_info_command = 129,             /* info_command  */
  YYSYMBOL_maintenance_command = 130,      /* maintenance_command  */
  YYSYMBOL_noprocess_state = 131,          /* noprocess_state  */
  YYSYMBOL_type_expr = 132,                /* type_expr  */
  YYSYMBOL_expr_lvalue = 133,              /* expr_lvalue  */
  YYSYMBOL_expr_rvalue = 134,              /* expr_rvalue  */
  YYSYMBOL_expr = 135,                     /* expr  */
  YYSYMBOL_lvalue_addr = 136,              /* lvalue_addr  */
  YYSYMBOL_lvalue = 137                    /* lvalue  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined DBG_STYPE_IS_TRIVIAL && DBG_STYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  171
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   916

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  112
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  26
/* YYNRULES -- Number of rules.  */
#define YYNRULES  229
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  343

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   346


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   100,     2,     2,     2,    98,    85,     2,
     109,   110,    96,    94,   107,    95,   103,    97,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   106,     2,
      88,   108,    89,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   104,     2,   111,    84,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    83,     2,   101,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    86,    87,
      90,    91,    92,    93,    99,   102,   105
};

#if DBG_DEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    96,    96,    97,   101,   102,   103,   104,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   162,
     163,   164,   168,   172,   173,   174,   175,   176,   182,   186,
     187,   191,   192,   193,   194,   195,   199,   200,   201,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     219,   220,   224,   225,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     248,   249,   250,   251,   256,   257,   258,   259,   260,   261,
     262,   263,   264,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   296,   297,
     298,   302,   303,   304,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     337,   341,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   398,   402,   403,   404,   405,   406,   407,   408
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if DBG_DEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "tCONT", "tPASS",
  "tSTEP", "tLIST", "tNEXT", "tQUIT", "tHELP", "tBACKTRACE", "tALL",
  "tINFO", "tUP", "tDOWN", "tENABLE", "tDISABLE", "tBREAK", "tHBREAK",
  "tWATCH", "tRWATCH", "tDELETE", "tSET", "tPRINT", "tEXAM", "tABORT",
  "tECHO", "tCLASS", "tMAPS", "tSTACK", "tSEGMENTS", "tSYMBOL", "tREGS",
  "tALLREGS", "tWND", "tLOCAL", "tEXCEPTION", "tPROCESS", "tTHREAD",
  "tEOL", "tEOF", "tFRAME", "tSHARE", "tMODULE", "tCOND", "tDISPLAY",
  "tUNDISPLAY", "tDISASSEMBLE", "tSTEPI", "tNEXTI", "tFINISH", "tSHOW",
  "tDIR", "tWHATIS", "tSOURCE", "tPATH", "tIDENTIFIER", "tSTRING",
  "tINTVAR", "tNUM", "tFORMAT", "tSYMBOLFILE", "tRUN", "tATTACH",
  "tDETACH", "tKILL", "tMAINTENANCE", "tTYPE", "tMINIDUMP", "tNOPROCESS",
  "tCHAR", "tSHORT", "tINT", "tLONG", "tFLOAT", "tDOUBLE", "tUNSIGNED",
  "tSIGNED", "tSTRUCT", "tUNION", "tENUM", "OP_LOR", "OP_LAND", "'|'",
  "'^'", "'&'", "OP_EQ", "OP_NE", "'<'", "'>'", "OP_LE", "OP_GE", "OP_SHL",
  "OP_SHR", "'+'", "'-'", "'*'", "'/'", "'%'", "OP_SIGN", "'!'", "'~'",
  "OP_DEREF", "'.'", "'['", "OP_DRF", "':'", "','", "'='", "'('", "')'",
  "']'", "$accept", "input", "line", "command", "pathname", "identifier",
  "list_arg", "run_command", "list_of_words", "list_command",
  "disassemble_command", "set_command", "x_command", "print_command",
  "break_command", "watch_command", "display_command", "info_command",
  "maintenance_command", "noprocess_state", "type_expr", "expr_lvalue",
  "expr_rvalue", "expr", "lvalue_addr", "lvalue", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-82)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-101)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     376,   -32,   -42,   -82,   -29,   195,   -24,   -82,    29,   -10,
      26,     7,    38,   -13,    53,   106,   203,    28,    47,    83,
     142,    90,   171,   -82,    15,    40,   -82,   -82,    43,    54,
     188,    62,   375,    86,    92,   -82,    74,   101,   375,   101,
     101,    31,    93,   -82,   -82,   -27,   101,    16,   307,   -82,
     125,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,
     -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,
     -82,   375,   222,    60,    61,    76,   -82,   -82,   -82,   -82,
     -82,   130,   375,   129,   375,   139,   -82,   -82,   375,   -82,
     -82,   -82,   -82,   375,   375,   -82,   163,   -82,   -82,   167,
     173,   -82,   180,   182,   -82,   -82,   375,   116,   204,   -82,
     375,   143,   214,   375,   -82,   375,   -82,   196,   198,   -82,
      46,   -82,   -82,    -6,    36,   375,   205,   -82,   155,    69,
     -82,   -82,   -82,   375,   375,   375,   375,   375,   375,   375,
      59,   159,   -82,   648,   375,   -82,   -82,   -82,   -82,   375,
     375,   648,   -82,   162,   -82,   -82,   -82,   -82,   -82,   -82,
     -82,   375,    31,   -82,   -82,   213,   -82,   231,   -82,   264,
     -82,   -82,   -82,   -82,   -82,   -82,    23,   222,   -82,   -82,
     -82,   -82,   -82,   -82,   -82,   -82,   -82,   375,   -82,   -82,
     -82,   -82,   -82,   217,   -82,   226,   -82,   -82,   -82,   -82,
      37,    67,   -82,   -82,   -82,   -82,   648,   230,   375,   236,
     375,   237,   -82,    89,    89,    89,    89,    89,    89,   238,
     -82,   -58,   -82,   -64,   -82,   -82,    13,   225,   238,   238,
     238,   -81,   588,   -20,   375,   375,   375,   375,   375,   375,
     375,   375,   375,   375,   375,   375,   375,   375,   375,   375,
     375,   375,   240,   375,   244,   375,   -82,   648,   648,   375,
     -82,   -82,   -82,   247,   -82,   -82,   -82,   -82,   -82,   -82,
     -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   406,   -82,
     -82,   -82,   215,   -82,   -45,   -82,   229,   -82,   -82,   -82,
     -82,   -82,   -82,   -82,   375,   -82,   -82,   468,   673,   697,
     720,   742,   763,   782,   782,   797,   797,   797,   797,   810,
     810,    73,    73,    89,    89,    89,   -82,   437,   -82,   199,
     -82,   -82,   -82,   -82,   -82,   262,   -82,    89,   375,   -82,
     -82,   -82,   498,   375,   -82,   528,   375,   -82,   558,   375,
     -82,   618,   -82
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,    12,    11,    14,    71,    16,     8,     9,    24,
       0,    27,    29,     0,     0,    98,   103,     0,     0,     0,
       0,     0,     0,    23,     0,     0,     5,     6,     0,     0,
     114,   122,    76,    18,    20,    22,     0,    34,     0,     0,
       0,    69,     0,    42,    44,     0,     0,   151,     0,     2,
       0,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,     7,    13,    15,    61,    62,    60,    63,
      72,     0,     0,     0,    65,    73,    17,    10,    26,    25,
     123,   135,   145,   131,   129,     0,   126,   127,   137,   133,
     147,   141,   142,   143,   124,   134,     0,    28,    30,     0,
       0,   104,     0,     0,   106,    97,     0,     0,    59,   102,
       0,     0,    59,     0,   111,     0,   113,     0,   120,   108,
      62,   224,   223,     0,     0,     0,     0,   225,     0,   222,
     183,   184,   182,     0,     0,     0,     0,     0,     0,     0,
       0,   185,    92,   180,     0,    90,    46,    43,    31,    35,
       0,   115,   121,    77,    19,    21,    32,    33,    59,    40,
      37,    38,    69,    68,    41,     0,   148,     0,    45,     0,
     153,     1,     3,     4,    67,    74,     0,     0,   136,   181,
     146,   130,   128,   132,   138,   144,   125,   139,   105,   117,
     107,   118,    94,     0,    99,     0,   110,   112,   109,   119,
       0,     0,    81,    80,    83,    82,   229,    89,     0,     0,
       0,     0,    93,   220,   215,   214,   219,   216,   217,     0,
     154,   163,   155,   157,   172,   173,   159,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    91,    36,   116,     0,
      39,    70,   149,     0,   152,    64,    66,    75,   140,    96,
     101,    85,    84,    87,    86,    88,    79,   227,     0,   226,
     176,   162,   165,   156,   171,   174,   161,   167,   158,   166,
     177,   178,   179,   175,     0,   218,   188,     0,   196,   197,
     198,   200,   199,   201,   206,   203,   202,   205,   204,   207,
     208,   209,   210,   211,   212,   213,   187,     0,   186,   195,
      78,   150,   228,   164,   170,   169,   160,   221,     0,   189,
     194,   168,     0,     0,   190,     0,     0,   191,     0,     0,
     192,     0,   193
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -82,   -82,   287,   -82,   440,     5,   -66,   -82,   174,   -82,
     -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,   -82,
     -82,   -19,   -60,   -30,   -82,   -82
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    48,    49,    50,    73,   141,    75,    51,   163,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
     231,   179,   180,   143,   128,   129
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     151,    78,   142,   145,    99,   202,   175,    63,   283,   284,
      74,   285,   286,   153,   281,   293,   165,    64,   282,   159,
     108,   112,   114,   116,   182,   127,   169,   324,   184,   294,
      65,   325,   100,   185,   186,    76,    67,   130,   131,   132,
     166,    77,   158,    80,   158,   158,   101,   204,   271,    79,
     203,   158,   174,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,   134,    97,    93,    94,   167,
     102,    95,   146,   170,   135,   136,   137,    74,   273,    67,
     138,   139,   265,   287,    67,   288,   219,   192,   162,   140,
     296,   194,   205,   272,   196,   206,   197,    98,   103,   147,
     117,   260,   148,    67,   213,   214,   215,   216,   217,   218,
     232,   267,   104,   149,   212,    67,   130,   131,   132,   257,
     258,   152,    96,   274,   113,   256,   156,   268,   118,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     200,   201,   119,   115,   134,   154,    67,   130,   131,   132,
     133,   155,   164,   135,   136,   137,    66,    67,    68,   138,
     139,    66,    67,    68,   173,   105,   176,   -59,   140,   249,
     250,   251,   209,   210,   211,   134,   252,   253,   254,   255,
     278,   266,    74,   177,   135,   136,   137,   178,   181,   276,
     138,   139,   252,   253,   254,   255,   183,   187,   120,   140,
     121,   122,   106,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   193,   317,   280,   319,   188,    67,   130,   131,
     132,   144,   189,   290,   291,   292,   123,   124,   125,   190,
     320,   191,   126,   -95,    67,   130,   131,   132,   150,   195,
      66,    67,    68,  -100,    69,   198,   134,   199,    66,    67,
      68,   207,   109,   208,   327,   135,   136,   137,   233,   259,
     262,   138,   139,   134,   263,   264,   269,    66,    67,    68,
     140,    69,   135,   136,   137,   270,   275,   323,   138,   139,
      70,    71,   277,   279,    67,   289,   316,   140,   332,   110,
     318,   326,    72,   335,   321,  -101,   338,   171,     1,   341,
       2,     3,     4,     5,     6,     7,     8,     9,    71,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,   331,   172,   261,     0,     0,     0,
       0,     0,     0,     0,     0,    25,    26,    27,    28,     0,
       0,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,     0,     0,     0,     0,     0,     0,    40,    41,
      42,    43,    44,    45,     0,    46,    47,     1,     0,     2,
       3,     4,     5,     6,     7,     8,     9,     0,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    25,    26,    27,    28,     0,     0,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    67,   130,   131,   132,     0,     0,    40,    41,    42,
      43,    44,    45,     0,    46,    47,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   107,   111,     0,     0,     0,
     134,     0,     0,     0,     0,     0,     0,     0,     0,   135,
     136,   137,     0,     0,     0,   138,   139,   157,     0,   160,
     161,     0,     0,     0,   140,     0,   168,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,     0,     0,     0,   252,
     253,   254,   255,     0,     0,     0,     0,   322,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,     0,     0,     0,
     252,   253,   254,   255,     0,     0,     0,     0,   330,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,   328,     0,     0,   329,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,   333,     0,     0,   334,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,   336,     0,     0,   337,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,   339,     0,     0,   340,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,     0,     0,     0,   295,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,     0,     0,     0,   342,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,     0,     0,
       0,   252,   253,   254,   255,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,     0,     0,     0,   252,   253,   254,   255,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,     0,     0,     0,
     252,   253,   254,   255,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,     0,
       0,     0,     0,   252,   253,   254,   255,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,     0,     0,     0,   252,   253,   254,   255,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,     0,     0,     0,   252,   253,   254,   255,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,     0,     0,     0,   252,   253,   254,   255,   245,
     246,   247,   248,   249,   250,   251,     0,     0,     0,     0,
     252,   253,   254,   255,   247,   248,   249,   250,   251,     0,
       0,     0,     0,   252,   253,   254,   255
};

static const yytype_int16 yycheck[] =
{
      30,    11,    21,    22,    17,    11,    72,    39,    72,    73,
       5,    75,    76,    32,    72,    96,    43,    59,    76,    38,
      15,    16,    17,    18,    84,    20,    10,    72,    88,   110,
      59,    76,    45,    93,    94,    59,    56,    57,    58,    59,
      67,    12,    37,    17,    39,    40,    59,    11,    11,    59,
      56,    46,    71,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    85,    59,    41,    42,    96,
      17,    45,    57,    57,    94,    95,    96,    72,    11,    56,
     100,   101,    59,    70,    56,    72,    27,   106,    57,   109,
     110,   110,    56,    56,   113,   125,   115,    59,    45,    59,
      17,   161,    59,    56,   134,   135,   136,   137,   138,   139,
     140,   177,    59,    59,   133,    56,    57,    58,    59,   149,
     150,    59,    96,    56,    96,   144,    52,   187,    45,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      94,    95,    59,    96,    85,    59,    56,    57,    58,    59,
      60,    59,    59,    94,    95,    96,    55,    56,    57,   100,
     101,    55,    56,    57,    39,    59,   106,   106,   109,    96,
      97,    98,   103,   104,   105,    85,   103,   104,   105,   106,
     210,   176,   177,   107,    94,    95,    96,    57,    59,   208,
     100,   101,   103,   104,   105,   106,    57,    34,    56,   109,
      58,    59,    96,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   106,   253,   219,   255,    59,    56,    57,    58,
      59,    60,    59,   228,   229,   230,    94,    95,    96,    59,
     259,    59,   100,    39,    56,    57,    58,    59,    60,   106,
      55,    56,    57,    39,    59,    59,    85,    59,    55,    56,
      57,    56,    59,   108,   294,    94,    95,    96,   109,   107,
      57,   100,   101,    85,    43,    11,    59,    55,    56,    57,
     109,    59,    94,    95,    96,    59,    56,    72,   100,   101,
      95,    96,    56,    56,    56,    70,    56,   109,   328,    96,
      56,    72,   107,   333,    57,   106,   336,     0,     1,   339,
       3,     4,     5,     6,     7,     8,     9,    10,    96,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    72,    48,   162,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    39,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    61,    62,
      63,    64,    65,    66,    -1,    68,    69,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    38,    39,    40,    41,    -1,    -1,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    56,    57,    58,    59,    -1,    -1,    61,    62,    63,
      64,    65,    66,    -1,    68,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    16,    -1,    -1,    -1,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      95,    96,    -1,    -1,    -1,   100,   101,    37,    -1,    39,
      40,    -1,    -1,    -1,   109,    -1,    46,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,    -1,    -1,    -1,   103,
     104,   105,   106,    -1,    -1,    -1,    -1,   111,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,    -1,    -1,    -1,
     103,   104,   105,   106,    -1,    -1,    -1,    -1,   111,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,   106,   107,    -1,    -1,   110,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,   106,   107,    -1,    -1,   110,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,   106,   107,    -1,    -1,   110,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,   106,   107,    -1,    -1,   110,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,   106,    -1,    -1,    -1,   110,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,   106,    -1,    -1,    -1,   110,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,    -1,    -1,
      -1,   103,   104,   105,   106,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,    -1,    -1,    -1,   103,   104,   105,   106,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,    -1,    -1,    -1,
     103,   104,   105,   106,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
      -1,    -1,    -1,   103,   104,   105,   106,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,    -1,    -1,    -1,   103,   104,   105,   106,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,    -1,    -1,    -1,   103,   104,   105,   106,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,    -1,    -1,    -1,   103,   104,   105,   106,    92,
      93,    94,    95,    96,    97,    98,    -1,    -1,    -1,    -1,
     103,   104,   105,   106,    94,    95,    96,    97,    98,    -1,
      -1,    -1,    -1,   103,   104,   105,   106
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    10,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    38,    39,    40,    41,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      61,    62,    63,    64,    65,    66,    68,    69,   113,   114,
     115,   119,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,    39,    59,    59,    55,    56,    57,    59,
      95,    96,   107,   116,   117,   118,    59,    12,    11,    59,
      17,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    41,    42,    45,    96,    59,    59,    17,
      45,    59,    17,    45,    59,    59,    96,   116,   117,    59,
      96,   116,   117,    96,   117,    96,   117,    17,    45,    59,
      56,    58,    59,    94,    95,    96,   100,   117,   136,   137,
      57,    58,    59,    60,    85,    94,    95,    96,   100,   101,
     109,   117,   133,   135,    60,   133,    57,    59,    59,    59,
      60,   135,    59,   133,    59,    59,    52,   116,   117,   133,
     116,   116,    57,   120,    59,    43,    67,    96,   116,    10,
      57,     0,   114,    39,   133,   118,   106,   107,    57,   133,
     134,    59,   134,    57,   134,   134,   134,    34,    59,    59,
      59,    59,   133,   106,   133,   106,   133,   133,    59,    59,
      94,    95,    11,    56,    11,    56,   135,    56,   108,   103,
     104,   105,   133,   135,   135,   135,   135,   135,   135,    27,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,   132,   135,   109,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,   103,   104,   105,   106,   133,   135,   135,   107,
     134,   120,    57,    43,    11,    59,   117,   118,   134,    59,
      59,    11,    56,    11,    56,    56,   133,    56,   135,    56,
     117,    72,    76,    72,    73,    75,    76,    70,    72,    70,
     117,   117,   117,    96,   110,   110,   110,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,    56,   135,    56,   135,
     133,    57,   111,    72,    72,    76,    72,   135,   107,   110,
     111,    72,   135,   107,   110,   135,   107,   110,   135,   107,
     110,   135,   110
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   112,   113,   113,   114,   114,   114,   114,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   115,
     115,   115,   115,   115,   115,   115,   115,   115,   115,   116,
     116,   116,   117,   118,   118,   118,   118,   118,   119,   120,
     120,   121,   121,   121,   121,   121,   122,   122,   122,   123,
     123,   123,   123,   123,   123,   123,   123,   123,   123,   123,
     124,   124,   125,   125,   126,   126,   126,   126,   126,   126,
     126,   126,   126,   126,   126,   126,   126,   126,   126,   126,
     127,   127,   127,   127,   128,   128,   128,   128,   128,   128,
     128,   128,   128,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   129,   129,
     129,   129,   129,   129,   129,   129,   129,   129,   130,   130,
     130,   131,   131,   131,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     133,   134,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   135,   136,   137,   137,   137,   137,   137,   137,   137
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     1,     2,     1,     1,
       2,     1,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     1,     1,     1,     2,     2,     1,     2,     1,
       2,     2,     2,     2,     1,     2,     3,     2,     2,     3,
       2,     2,     1,     2,     1,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     2,     2,     0,
       2,     1,     2,     2,     3,     4,     1,     2,     4,     4,
       3,     3,     3,     3,     4,     4,     4,     4,     4,     3,
       2,     3,     2,     3,     3,     2,     4,     2,     1,     3,
       2,     4,     2,     1,     2,     3,     2,     3,     2,     3,
       3,     2,     3,     2,     1,     2,     3,     3,     3,     3,
       2,     2,     1,     2,     2,     3,     2,     2,     3,     2,
       3,     2,     3,     2,     2,     2,     3,     2,     3,     3,
       4,     2,     2,     2,     3,     2,     3,     2,     2,     3,
       4,     1,     3,     2,     1,     1,     2,     1,     2,     1,
       3,     2,     2,     1,     3,     2,     2,     2,     4,     3,
       3,     2,     1,     1,     2,     2,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     4,
       6,     8,    10,    12,     4,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     2,     2,     3,     2,
       2,     4,     1,     1,     1,     1,     3,     3,     4,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = DBG_EMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == DBG_EMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use DBG_error or DBG_UNDEF. */
#define YYERRCODE DBG_UNDEF


/* Enable debugging if requested.  */
#if DBG_DEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !DBG_DEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !DBG_DEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = DBG_EMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == DBG_EMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= DBG_EOF)
    {
      yychar = DBG_EOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == DBG_error)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = DBG_UNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = DBG_EMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 4: /* line: command tEOL  */
#line 101 "programs/winedbg/dbg.y"
                                { expr_free_all(); }
#line 1757 "programs/winedbg/dbg.tab.c"
    break;

  case 6: /* line: tEOF  */
#line 103 "programs/winedbg/dbg.y"
                                { return 1; }
#line 1763 "programs/winedbg/dbg.tab.c"
    break;

  case 7: /* line: error tEOL  */
#line 104 "programs/winedbg/dbg.y"
                                { yyerrok; expr_free_all(); }
#line 1769 "programs/winedbg/dbg.tab.c"
    break;

  case 8: /* command: tQUIT  */
#line 108 "programs/winedbg/dbg.y"
                                { return 1; }
#line 1775 "programs/winedbg/dbg.tab.c"
    break;

  case 9: /* command: tHELP  */
#line 109 "programs/winedbg/dbg.y"
                                { print_help(); }
#line 1781 "programs/winedbg/dbg.tab.c"
    break;

  case 10: /* command: tHELP tINFO  */
#line 110 "programs/winedbg/dbg.y"
                                { info_help(); }
#line 1787 "programs/winedbg/dbg.tab.c"
    break;

  case 11: /* command: tPASS  */
#line 111 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_EXCEPTION_NOT_HANDLED, 0, 0); }
#line 1793 "programs/winedbg/dbg.tab.c"
    break;

  case 12: /* command: tCONT  */
#line 112 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, 1,  dbg_exec_cont); }
#line 1799 "programs/winedbg/dbg.tab.c"
    break;

  case 13: /* command: tCONT tNUM  */
#line 113 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, (yyvsp[0].integer), dbg_exec_cont); }
#line 1805 "programs/winedbg/dbg.tab.c"
    break;

  case 14: /* command: tSTEP  */
#line 114 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, 1,  dbg_exec_step_into_line); }
#line 1811 "programs/winedbg/dbg.tab.c"
    break;

  case 15: /* command: tSTEP tNUM  */
#line 115 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, (yyvsp[0].integer), dbg_exec_step_into_line); }
#line 1817 "programs/winedbg/dbg.tab.c"
    break;

  case 16: /* command: tNEXT  */
#line 116 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, 1,  dbg_exec_step_over_line); }
#line 1823 "programs/winedbg/dbg.tab.c"
    break;

  case 17: /* command: tNEXT tNUM  */
#line 117 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, (yyvsp[0].integer), dbg_exec_step_over_line); }
#line 1829 "programs/winedbg/dbg.tab.c"
    break;

  case 18: /* command: tSTEPI  */
#line 118 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, 1,  dbg_exec_step_into_insn); }
#line 1835 "programs/winedbg/dbg.tab.c"
    break;

  case 19: /* command: tSTEPI tNUM  */
#line 119 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, (yyvsp[0].integer), dbg_exec_step_into_insn); }
#line 1841 "programs/winedbg/dbg.tab.c"
    break;

  case 20: /* command: tNEXTI  */
#line 120 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, 1,  dbg_exec_step_over_insn); }
#line 1847 "programs/winedbg/dbg.tab.c"
    break;

  case 21: /* command: tNEXTI tNUM  */
#line 121 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, (yyvsp[0].integer), dbg_exec_step_over_insn); }
#line 1853 "programs/winedbg/dbg.tab.c"
    break;

  case 22: /* command: tFINISH  */
#line 122 "programs/winedbg/dbg.y"
                                { dbg_wait_next_exception(DBG_CONTINUE, 0,  dbg_exec_finish); }
#line 1859 "programs/winedbg/dbg.tab.c"
    break;

  case 23: /* command: tABORT  */
#line 123 "programs/winedbg/dbg.y"
                                { abort(); }
#line 1865 "programs/winedbg/dbg.tab.c"
    break;

  case 24: /* command: tBACKTRACE  */
#line 124 "programs/winedbg/dbg.y"
                                { stack_backtrace(dbg_curr_tid); }
#line 1871 "programs/winedbg/dbg.tab.c"
    break;

  case 25: /* command: tBACKTRACE tNUM  */
#line 125 "programs/winedbg/dbg.y"
                                { stack_backtrace((yyvsp[0].integer)); }
#line 1877 "programs/winedbg/dbg.tab.c"
    break;

  case 26: /* command: tBACKTRACE tALL  */
#line 126 "programs/winedbg/dbg.y"
                                { stack_backtrace(-1); }
#line 1883 "programs/winedbg/dbg.tab.c"
    break;

  case 27: /* command: tUP  */
#line 127 "programs/winedbg/dbg.y"
                                { stack_set_frame(dbg_curr_thread->curr_frame + 1);  }
#line 1889 "programs/winedbg/dbg.tab.c"
    break;

  case 28: /* command: tUP tNUM  */
#line 128 "programs/winedbg/dbg.y"
                                { stack_set_frame(dbg_curr_thread->curr_frame + (yyvsp[0].integer)); }
#line 1895 "programs/winedbg/dbg.tab.c"
    break;

  case 29: /* command: tDOWN  */
#line 129 "programs/winedbg/dbg.y"
                                { stack_set_frame(dbg_curr_thread->curr_frame - 1);  }
#line 1901 "programs/winedbg/dbg.tab.c"
    break;

  case 30: /* command: tDOWN tNUM  */
#line 130 "programs/winedbg/dbg.y"
                                { stack_set_frame(dbg_curr_thread->curr_frame - (yyvsp[0].integer)); }
#line 1907 "programs/winedbg/dbg.tab.c"
    break;

  case 31: /* command: tFRAME tNUM  */
#line 131 "programs/winedbg/dbg.y"
                                { stack_set_frame((yyvsp[0].integer)); }
#line 1913 "programs/winedbg/dbg.tab.c"
    break;

  case 32: /* command: tSHOW tDIR  */
#line 132 "programs/winedbg/dbg.y"
                                { source_show_path(); }
#line 1919 "programs/winedbg/dbg.tab.c"
    break;

  case 33: /* command: tDIR pathname  */
#line 133 "programs/winedbg/dbg.y"
                                { source_add_path((yyvsp[0].string)); }
#line 1925 "programs/winedbg/dbg.tab.c"
    break;

  case 34: /* command: tDIR  */
#line 134 "programs/winedbg/dbg.y"
                                { source_nuke_path(dbg_curr_process); }
#line 1931 "programs/winedbg/dbg.tab.c"
    break;

  case 35: /* command: tCOND tNUM  */
#line 135 "programs/winedbg/dbg.y"
                                { break_add_condition((yyvsp[0].integer), NULL); }
#line 1937 "programs/winedbg/dbg.tab.c"
    break;

  case 36: /* command: tCOND tNUM expr  */
#line 136 "programs/winedbg/dbg.y"
                                { break_add_condition((yyvsp[-1].integer), (yyvsp[0].expression)); }
#line 1943 "programs/winedbg/dbg.tab.c"
    break;

  case 37: /* command: tSOURCE pathname  */
#line 137 "programs/winedbg/dbg.y"
                                { parser((yyvsp[0].string)); }
#line 1949 "programs/winedbg/dbg.tab.c"
    break;

  case 38: /* command: tSYMBOLFILE pathname  */
#line 138 "programs/winedbg/dbg.y"
                                { symbol_read_symtable((yyvsp[0].string), 0); }
#line 1955 "programs/winedbg/dbg.tab.c"
    break;

  case 39: /* command: tSYMBOLFILE pathname expr_rvalue  */
#line 139 "programs/winedbg/dbg.y"
                                       { symbol_read_symtable((yyvsp[-1].string), (yyvsp[0].integer)); }
#line 1961 "programs/winedbg/dbg.tab.c"
    break;

  case 40: /* command: tWHATIS expr_lvalue  */
#line 140 "programs/winedbg/dbg.y"
                                { dbg_printf("type = "); types_print_type(&(yyvsp[0].lvalue).type, FALSE); dbg_printf("\n"); }
#line 1967 "programs/winedbg/dbg.tab.c"
    break;

  case 41: /* command: tATTACH tNUM  */
#line 141 "programs/winedbg/dbg.y"
                                { dbg_attach_debuggee((yyvsp[0].integer)); dbg_active_wait_for_first_exception(); }
#line 1973 "programs/winedbg/dbg.tab.c"
    break;

  case 42: /* command: tDETACH  */
#line 142 "programs/winedbg/dbg.y"
                                { dbg_curr_process->process_io->close_process(dbg_curr_process, FALSE); }
#line 1979 "programs/winedbg/dbg.tab.c"
    break;

  case 43: /* command: tTHREAD tNUM  */
#line 143 "programs/winedbg/dbg.y"
                                { dbg_set_curr_thread((yyvsp[0].integer)); }
#line 1985 "programs/winedbg/dbg.tab.c"
    break;

  case 44: /* command: tKILL  */
#line 144 "programs/winedbg/dbg.y"
                                { dbg_curr_process->process_io->close_process(dbg_curr_process, TRUE); }
#line 1991 "programs/winedbg/dbg.tab.c"
    break;

  case 45: /* command: tMINIDUMP pathname  */
#line 145 "programs/winedbg/dbg.y"
                                { minidump_write((yyvsp[0].string), (dbg_curr_thread && dbg_curr_thread->in_exception) ? &dbg_curr_thread->excpt_record : NULL);}
#line 1997 "programs/winedbg/dbg.tab.c"
    break;

  case 46: /* command: tECHO tSTRING  */
#line 146 "programs/winedbg/dbg.y"
                                { dbg_printf("%s\n", (yyvsp[0].string)); }
#line 2003 "programs/winedbg/dbg.tab.c"
    break;

  case 59: /* pathname: identifier  */
#line 162 "programs/winedbg/dbg.y"
                                { (yyval.string) = (yyvsp[0].string); }
#line 2009 "programs/winedbg/dbg.tab.c"
    break;

  case 60: /* pathname: tSTRING  */
#line 163 "programs/winedbg/dbg.y"
                                { (yyval.string) = (yyvsp[0].string); }
#line 2015 "programs/winedbg/dbg.tab.c"
    break;

  case 61: /* pathname: tPATH  */
#line 164 "programs/winedbg/dbg.y"
                                { (yyval.string) = (yyvsp[0].string); }
#line 2021 "programs/winedbg/dbg.tab.c"
    break;

  case 62: /* identifier: tIDENTIFIER  */
#line 168 "programs/winedbg/dbg.y"
                               { (yyval.string) = (yyvsp[0].string); }
#line 2027 "programs/winedbg/dbg.tab.c"
    break;

  case 63: /* list_arg: tNUM  */
#line 172 "programs/winedbg/dbg.y"
                                { (yyval.listing).FileName = NULL; (yyval.listing).LineNumber = (yyvsp[0].integer); }
#line 2033 "programs/winedbg/dbg.tab.c"
    break;

  case 64: /* list_arg: pathname ':' tNUM  */
#line 173 "programs/winedbg/dbg.y"
                                { (yyval.listing).FileName = (yyvsp[-2].string); (yyval.listing).LineNumber = (yyvsp[0].integer); }
#line 2039 "programs/winedbg/dbg.tab.c"
    break;

  case 65: /* list_arg: identifier  */
#line 174 "programs/winedbg/dbg.y"
                                { symbol_get_line(NULL, (yyvsp[0].string), &(yyval.listing)); }
#line 2045 "programs/winedbg/dbg.tab.c"
    break;

  case 66: /* list_arg: pathname ':' identifier  */
#line 175 "programs/winedbg/dbg.y"
                                { symbol_get_line((yyvsp[-2].string), (yyvsp[0].string), &(yyval.listing)); }
#line 2051 "programs/winedbg/dbg.tab.c"
    break;

  case 67: /* list_arg: '*' expr_lvalue  */
#line 176 "programs/winedbg/dbg.y"
                                { DWORD disp; ADDRESS64 addr; (yyval.listing).SizeOfStruct = sizeof((yyval.listing));
                                  types_extract_as_address(&(yyvsp[0].lvalue), &addr);
                                  SymGetLineFromAddr64(dbg_curr_process->handle, (ULONG_PTR)memory_to_linear_addr(& addr), &disp, & (yyval.listing)); }
#line 2059 "programs/winedbg/dbg.tab.c"
    break;

  case 68: /* run_command: tRUN list_of_words  */
#line 182 "programs/winedbg/dbg.y"
                                { dbg_run_debuggee((yyvsp[0].strings)); }
#line 2065 "programs/winedbg/dbg.tab.c"
    break;

  case 69: /* list_of_words: %empty  */
#line 186 "programs/winedbg/dbg.y"
                                { (yyval.strings) = NULL; }
#line 2071 "programs/winedbg/dbg.tab.c"
    break;

  case 70: /* list_of_words: tSTRING list_of_words  */
#line 187 "programs/winedbg/dbg.y"
                                { (yyval.strings) = (struct list_string*)lexeme_alloc_size(sizeof(*(yyval.strings))); (yyval.strings)->next = (yyvsp[0].strings); (yyval.strings)->string = (yyvsp[-1].string); }
#line 2077 "programs/winedbg/dbg.tab.c"
    break;

  case 71: /* list_command: tLIST  */
#line 191 "programs/winedbg/dbg.y"
                                { source_list(NULL, NULL, 10); }
#line 2083 "programs/winedbg/dbg.tab.c"
    break;

  case 72: /* list_command: tLIST '-'  */
#line 192 "programs/winedbg/dbg.y"
                                { source_list(NULL,  NULL, -10); }
#line 2089 "programs/winedbg/dbg.tab.c"
    break;

  case 73: /* list_command: tLIST list_arg  */
#line 193 "programs/winedbg/dbg.y"
                                { source_list(& (yyvsp[0].listing), NULL, 10); }
#line 2095 "programs/winedbg/dbg.tab.c"
    break;

  case 74: /* list_command: tLIST ',' list_arg  */
#line 194 "programs/winedbg/dbg.y"
                                { source_list(NULL, & (yyvsp[0].listing), -10); }
#line 2101 "programs/winedbg/dbg.tab.c"
    break;

  case 75: /* list_command: tLIST list_arg ',' list_arg  */
#line 195 "programs/winedbg/dbg.y"
                                       { source_list(& (yyvsp[-2].listing), & (yyvsp[0].listing), 0); }
#line 2107 "programs/winedbg/dbg.tab.c"
    break;

  case 76: /* disassemble_command: tDISASSEMBLE  */
#line 199 "programs/winedbg/dbg.y"
                                { memory_disassemble(NULL, NULL, 10); }
#line 2113 "programs/winedbg/dbg.tab.c"
    break;

  case 77: /* disassemble_command: tDISASSEMBLE expr_lvalue  */
#line 200 "programs/winedbg/dbg.y"
                                { memory_disassemble(&(yyvsp[0].lvalue), NULL, 10); }
#line 2119 "programs/winedbg/dbg.tab.c"
    break;

  case 78: /* disassemble_command: tDISASSEMBLE expr_lvalue ',' expr_lvalue  */
#line 201 "programs/winedbg/dbg.y"
                                               { memory_disassemble(&(yyvsp[-2].lvalue), &(yyvsp[0].lvalue), 0); }
#line 2125 "programs/winedbg/dbg.tab.c"
    break;

  case 79: /* set_command: tSET lvalue_addr '=' expr_lvalue  */
#line 205 "programs/winedbg/dbg.y"
                                       { types_store_value(&(yyvsp[-2].lvalue), &(yyvsp[0].lvalue)); }
#line 2131 "programs/winedbg/dbg.tab.c"
    break;

  case 80: /* set_command: tSET '+' tIDENTIFIER  */
#line 206 "programs/winedbg/dbg.y"
                                { info_wine_dbg_channel(TRUE, NULL, (yyvsp[0].string)); }
#line 2137 "programs/winedbg/dbg.tab.c"
    break;

  case 81: /* set_command: tSET '+' tALL  */
#line 207 "programs/winedbg/dbg.y"
                                { info_wine_dbg_channel(TRUE, NULL, "all"); }
#line 2143 "programs/winedbg/dbg.tab.c"
    break;

  case 82: /* set_command: tSET '-' tIDENTIFIER  */
#line 208 "programs/winedbg/dbg.y"
                                { info_wine_dbg_channel(FALSE, NULL, (yyvsp[0].string)); }
#line 2149 "programs/winedbg/dbg.tab.c"
    break;

  case 83: /* set_command: tSET '-' tALL  */
#line 209 "programs/winedbg/dbg.y"
                                { info_wine_dbg_channel(FALSE, NULL, "all"); }
#line 2155 "programs/winedbg/dbg.tab.c"
    break;

  case 84: /* set_command: tSET tIDENTIFIER '+' tIDENTIFIER  */
#line 210 "programs/winedbg/dbg.y"
                                       { info_wine_dbg_channel(TRUE, (yyvsp[-2].string), (yyvsp[0].string)); }
#line 2161 "programs/winedbg/dbg.tab.c"
    break;

  case 85: /* set_command: tSET tIDENTIFIER '+' tALL  */
#line 211 "programs/winedbg/dbg.y"
                                       { info_wine_dbg_channel(TRUE, (yyvsp[-2].string), "all"); }
#line 2167 "programs/winedbg/dbg.tab.c"
    break;

  case 86: /* set_command: tSET tIDENTIFIER '-' tIDENTIFIER  */
#line 212 "programs/winedbg/dbg.y"
                                       { info_wine_dbg_channel(FALSE, (yyvsp[-2].string), (yyvsp[0].string)); }
#line 2173 "programs/winedbg/dbg.tab.c"
    break;

  case 87: /* set_command: tSET tIDENTIFIER '-' tALL  */
#line 213 "programs/winedbg/dbg.y"
                                       { info_wine_dbg_channel(FALSE, (yyvsp[-2].string), "all"); }
#line 2179 "programs/winedbg/dbg.tab.c"
    break;

  case 88: /* set_command: tSET '!' tIDENTIFIER tIDENTIFIER  */
#line 214 "programs/winedbg/dbg.y"
                                        { dbg_set_option((yyvsp[-1].string), (yyvsp[0].string)); }
#line 2185 "programs/winedbg/dbg.tab.c"
    break;

  case 89: /* set_command: tSET '!' tIDENTIFIER  */
#line 215 "programs/winedbg/dbg.y"
                                { dbg_set_option((yyvsp[0].string), NULL); }
#line 2191 "programs/winedbg/dbg.tab.c"
    break;

  case 90: /* x_command: tEXAM expr_lvalue  */
#line 219 "programs/winedbg/dbg.y"
                                { memory_examine(&(yyvsp[0].lvalue), 1, 'x'); }
#line 2197 "programs/winedbg/dbg.tab.c"
    break;

  case 91: /* x_command: tEXAM tFORMAT expr_lvalue  */
#line 220 "programs/winedbg/dbg.y"
                                { memory_examine(&(yyvsp[0].lvalue), (yyvsp[-1].integer) >> 8, (yyvsp[-1].integer) & 0xff); }
#line 2203 "programs/winedbg/dbg.tab.c"
    break;

  case 92: /* print_command: tPRINT expr_lvalue  */
#line 224 "programs/winedbg/dbg.y"
                                 { print_value(&(yyvsp[0].lvalue), 0, 0); }
#line 2209 "programs/winedbg/dbg.tab.c"
    break;

  case 93: /* print_command: tPRINT tFORMAT expr_lvalue  */
#line 225 "programs/winedbg/dbg.y"
                                 { if (((yyvsp[-1].integer) >> 8) == 1) print_value(&(yyvsp[0].lvalue), (yyvsp[-1].integer) & 0xff, 0); else dbg_printf("Count is meaningless in print command\n"); }
#line 2215 "programs/winedbg/dbg.tab.c"
    break;

  case 94: /* break_command: tBREAK '*' expr_lvalue  */
#line 229 "programs/winedbg/dbg.y"
                                { break_add_break_from_lvalue(&(yyvsp[0].lvalue), TRUE); }
#line 2221 "programs/winedbg/dbg.tab.c"
    break;

  case 95: /* break_command: tBREAK identifier  */
#line 230 "programs/winedbg/dbg.y"
                                { break_add_break_from_id((yyvsp[0].string), -1, TRUE); }
#line 2227 "programs/winedbg/dbg.tab.c"
    break;

  case 96: /* break_command: tBREAK pathname ':' tNUM  */
#line 231 "programs/winedbg/dbg.y"
                                { break_add_break_from_lineno((yyvsp[-2].string), (yyvsp[0].integer), TRUE); }
#line 2233 "programs/winedbg/dbg.tab.c"
    break;

  case 97: /* break_command: tBREAK tNUM  */
#line 232 "programs/winedbg/dbg.y"
                                { break_add_break_from_lineno(NULL, (yyvsp[0].integer), TRUE); }
#line 2239 "programs/winedbg/dbg.tab.c"
    break;

  case 98: /* break_command: tBREAK  */
#line 233 "programs/winedbg/dbg.y"
                                { break_add_break_from_lineno(NULL, -1, TRUE); }
#line 2245 "programs/winedbg/dbg.tab.c"
    break;

  case 99: /* break_command: tHBREAK '*' expr_lvalue  */
#line 234 "programs/winedbg/dbg.y"
                                { break_add_break_from_lvalue(&(yyvsp[0].lvalue), FALSE); }
#line 2251 "programs/winedbg/dbg.tab.c"
    break;

  case 100: /* break_command: tHBREAK identifier  */
#line 235 "programs/winedbg/dbg.y"
                                { break_add_break_from_id((yyvsp[0].string), -1, FALSE); }
#line 2257 "programs/winedbg/dbg.tab.c"
    break;

  case 101: /* break_command: tHBREAK pathname ':' tNUM  */
#line 236 "programs/winedbg/dbg.y"
                                { break_add_break_from_lineno((yyvsp[-2].string), (yyvsp[0].integer), FALSE); }
#line 2263 "programs/winedbg/dbg.tab.c"
    break;

  case 102: /* break_command: tHBREAK tNUM  */
#line 237 "programs/winedbg/dbg.y"
                                { break_add_break_from_lineno(NULL, (yyvsp[0].integer), FALSE); }
#line 2269 "programs/winedbg/dbg.tab.c"
    break;

  case 103: /* break_command: tHBREAK  */
#line 238 "programs/winedbg/dbg.y"
                                { break_add_break_from_lineno(NULL, -1, FALSE); }
#line 2275 "programs/winedbg/dbg.tab.c"
    break;

  case 104: /* break_command: tENABLE tNUM  */
#line 239 "programs/winedbg/dbg.y"
                                { break_enable_xpoint((yyvsp[0].integer), TRUE); }
#line 2281 "programs/winedbg/dbg.tab.c"
    break;

  case 105: /* break_command: tENABLE tBREAK tNUM  */
#line 240 "programs/winedbg/dbg.y"
                                { break_enable_xpoint((yyvsp[0].integer), TRUE); }
#line 2287 "programs/winedbg/dbg.tab.c"
    break;

  case 106: /* break_command: tDISABLE tNUM  */
#line 241 "programs/winedbg/dbg.y"
                                { break_enable_xpoint((yyvsp[0].integer), FALSE); }
#line 2293 "programs/winedbg/dbg.tab.c"
    break;

  case 107: /* break_command: tDISABLE tBREAK tNUM  */
#line 242 "programs/winedbg/dbg.y"
                                { break_enable_xpoint((yyvsp[0].integer), FALSE); }
#line 2299 "programs/winedbg/dbg.tab.c"
    break;

  case 108: /* break_command: tDELETE tNUM  */
#line 243 "programs/winedbg/dbg.y"
                                { break_delete_xpoint((yyvsp[0].integer)); }
#line 2305 "programs/winedbg/dbg.tab.c"
    break;

  case 109: /* break_command: tDELETE tBREAK tNUM  */
#line 244 "programs/winedbg/dbg.y"
                                { break_delete_xpoint((yyvsp[0].integer)); }
#line 2311 "programs/winedbg/dbg.tab.c"
    break;

  case 110: /* watch_command: tWATCH '*' expr_lvalue  */
#line 248 "programs/winedbg/dbg.y"
                                { break_add_watch_from_lvalue(&(yyvsp[0].lvalue), TRUE); }
#line 2317 "programs/winedbg/dbg.tab.c"
    break;

  case 111: /* watch_command: tWATCH identifier  */
#line 249 "programs/winedbg/dbg.y"
                                { break_add_watch_from_id((yyvsp[0].string), TRUE); }
#line 2323 "programs/winedbg/dbg.tab.c"
    break;

  case 112: /* watch_command: tRWATCH '*' expr_lvalue  */
#line 250 "programs/winedbg/dbg.y"
                                { break_add_watch_from_lvalue(&(yyvsp[0].lvalue), FALSE); }
#line 2329 "programs/winedbg/dbg.tab.c"
    break;

  case 113: /* watch_command: tRWATCH identifier  */
#line 251 "programs/winedbg/dbg.y"
                                { break_add_watch_from_id((yyvsp[0].string), FALSE); }
#line 2335 "programs/winedbg/dbg.tab.c"
    break;

  case 114: /* display_command: tDISPLAY  */
#line 256 "programs/winedbg/dbg.y"
                                { display_print(); }
#line 2341 "programs/winedbg/dbg.tab.c"
    break;

  case 115: /* display_command: tDISPLAY expr  */
#line 257 "programs/winedbg/dbg.y"
                                { display_add((yyvsp[0].expression), 1, 0); }
#line 2347 "programs/winedbg/dbg.tab.c"
    break;

  case 116: /* display_command: tDISPLAY tFORMAT expr  */
#line 258 "programs/winedbg/dbg.y"
                                { display_add((yyvsp[0].expression), (yyvsp[-1].integer) >> 8, (yyvsp[-1].integer) & 0xff); }
#line 2353 "programs/winedbg/dbg.tab.c"
    break;

  case 117: /* display_command: tENABLE tDISPLAY tNUM  */
#line 259 "programs/winedbg/dbg.y"
                                { display_enable((yyvsp[0].integer), TRUE); }
#line 2359 "programs/winedbg/dbg.tab.c"
    break;

  case 118: /* display_command: tDISABLE tDISPLAY tNUM  */
#line 260 "programs/winedbg/dbg.y"
                                { display_enable((yyvsp[0].integer), FALSE); }
#line 2365 "programs/winedbg/dbg.tab.c"
    break;

  case 119: /* display_command: tDELETE tDISPLAY tNUM  */
#line 261 "programs/winedbg/dbg.y"
                                { display_delete((yyvsp[0].integer)); }
#line 2371 "programs/winedbg/dbg.tab.c"
    break;

  case 120: /* display_command: tDELETE tDISPLAY  */
#line 262 "programs/winedbg/dbg.y"
                                { display_delete(-1); }
#line 2377 "programs/winedbg/dbg.tab.c"
    break;

  case 121: /* display_command: tUNDISPLAY tNUM  */
#line 263 "programs/winedbg/dbg.y"
                                { display_delete((yyvsp[0].integer)); }
#line 2383 "programs/winedbg/dbg.tab.c"
    break;

  case 122: /* display_command: tUNDISPLAY  */
#line 264 "programs/winedbg/dbg.y"
                                { display_delete(-1); }
#line 2389 "programs/winedbg/dbg.tab.c"
    break;

  case 123: /* info_command: tINFO tBREAK  */
#line 268 "programs/winedbg/dbg.y"
                                { break_info(); }
#line 2395 "programs/winedbg/dbg.tab.c"
    break;

  case 124: /* info_command: tINFO tSHARE  */
#line 269 "programs/winedbg/dbg.y"
                                { info_win32_module(0); }
#line 2401 "programs/winedbg/dbg.tab.c"
    break;

  case 125: /* info_command: tINFO tSHARE expr_rvalue  */
#line 270 "programs/winedbg/dbg.y"
                                { info_win32_module((yyvsp[0].integer)); }
#line 2407 "programs/winedbg/dbg.tab.c"
    break;

  case 126: /* info_command: tINFO tREGS  */
#line 271 "programs/winedbg/dbg.y"
                                { dbg_curr_process->be_cpu->print_context(dbg_curr_thread->handle, &dbg_context, 0); }
#line 2413 "programs/winedbg/dbg.tab.c"
    break;

  case 127: /* info_command: tINFO tALLREGS  */
#line 272 "programs/winedbg/dbg.y"
                                { dbg_curr_process->be_cpu->print_context(dbg_curr_thread->handle, &dbg_context, 1); }
#line 2419 "programs/winedbg/dbg.tab.c"
    break;

  case 128: /* info_command: tINFO tSEGMENTS expr_rvalue  */
#line 273 "programs/winedbg/dbg.y"
                                  { info_win32_segments((yyvsp[0].integer) >> 3, 1); }
#line 2425 "programs/winedbg/dbg.tab.c"
    break;

  case 129: /* info_command: tINFO tSEGMENTS  */
#line 274 "programs/winedbg/dbg.y"
                                { info_win32_segments(0, -1); }
#line 2431 "programs/winedbg/dbg.tab.c"
    break;

  case 130: /* info_command: tINFO tSTACK tNUM  */
#line 275 "programs/winedbg/dbg.y"
                                { stack_info((yyvsp[0].integer)); }
#line 2437 "programs/winedbg/dbg.tab.c"
    break;

  case 131: /* info_command: tINFO tSTACK  */
#line 276 "programs/winedbg/dbg.y"
                                { stack_info(-1); }
#line 2443 "programs/winedbg/dbg.tab.c"
    break;

  case 132: /* info_command: tINFO tSYMBOL tSTRING  */
#line 277 "programs/winedbg/dbg.y"
                                { symbol_info((yyvsp[0].string)); }
#line 2449 "programs/winedbg/dbg.tab.c"
    break;

  case 133: /* info_command: tINFO tLOCAL  */
#line 278 "programs/winedbg/dbg.y"
                                { symbol_info_locals(); }
#line 2455 "programs/winedbg/dbg.tab.c"
    break;

  case 134: /* info_command: tINFO tDISPLAY  */
#line 279 "programs/winedbg/dbg.y"
                                { display_info(); }
#line 2461 "programs/winedbg/dbg.tab.c"
    break;

  case 135: /* info_command: tINFO tCLASS  */
#line 280 "programs/winedbg/dbg.y"
                                { info_win32_class(NULL, NULL); }
#line 2467 "programs/winedbg/dbg.tab.c"
    break;

  case 136: /* info_command: tINFO tCLASS tSTRING  */
#line 281 "programs/winedbg/dbg.y"
                                { info_win32_class(NULL, (yyvsp[0].string)); }
#line 2473 "programs/winedbg/dbg.tab.c"
    break;

  case 137: /* info_command: tINFO tWND  */
#line 282 "programs/winedbg/dbg.y"
                                { info_win32_window(NULL, FALSE); }
#line 2479 "programs/winedbg/dbg.tab.c"
    break;

  case 138: /* info_command: tINFO tWND expr_rvalue  */
#line 283 "programs/winedbg/dbg.y"
                                { info_win32_window((HWND)(DWORD_PTR)(yyvsp[0].integer), FALSE); }
#line 2485 "programs/winedbg/dbg.tab.c"
    break;

  case 139: /* info_command: tINFO '*' tWND  */
#line 284 "programs/winedbg/dbg.y"
                                { info_win32_window(NULL, TRUE); }
#line 2491 "programs/winedbg/dbg.tab.c"
    break;

  case 140: /* info_command: tINFO '*' tWND expr_rvalue  */
#line 285 "programs/winedbg/dbg.y"
                                 { info_win32_window((HWND)(DWORD_PTR)(yyvsp[0].integer), TRUE); }
#line 2497 "programs/winedbg/dbg.tab.c"
    break;

  case 141: /* info_command: tINFO tPROCESS  */
#line 286 "programs/winedbg/dbg.y"
                                { info_win32_processes(); }
#line 2503 "programs/winedbg/dbg.tab.c"
    break;

  case 142: /* info_command: tINFO tTHREAD  */
#line 287 "programs/winedbg/dbg.y"
                                { info_win32_threads(); }
#line 2509 "programs/winedbg/dbg.tab.c"
    break;

  case 143: /* info_command: tINFO tFRAME  */
#line 288 "programs/winedbg/dbg.y"
                                { info_win32_frame_exceptions(dbg_curr_tid); }
#line 2515 "programs/winedbg/dbg.tab.c"
    break;

  case 144: /* info_command: tINFO tFRAME expr_rvalue  */
#line 289 "programs/winedbg/dbg.y"
                                { info_win32_frame_exceptions((yyvsp[0].integer)); }
#line 2521 "programs/winedbg/dbg.tab.c"
    break;

  case 145: /* info_command: tINFO tMAPS  */
#line 290 "programs/winedbg/dbg.y"
                                { info_win32_virtual(dbg_curr_pid); }
#line 2527 "programs/winedbg/dbg.tab.c"
    break;

  case 146: /* info_command: tINFO tMAPS expr_rvalue  */
#line 291 "programs/winedbg/dbg.y"
                                { info_win32_virtual((yyvsp[0].integer)); }
#line 2533 "programs/winedbg/dbg.tab.c"
    break;

  case 147: /* info_command: tINFO tEXCEPTION  */
#line 292 "programs/winedbg/dbg.y"
                                { info_win32_exception(); }
#line 2539 "programs/winedbg/dbg.tab.c"
    break;

  case 148: /* maintenance_command: tMAINTENANCE tTYPE  */
#line 296 "programs/winedbg/dbg.y"
                                { print_types(); }
#line 2545 "programs/winedbg/dbg.tab.c"
    break;

  case 149: /* maintenance_command: tMAINTENANCE tMODULE tSTRING  */
#line 297 "programs/winedbg/dbg.y"
                                   { tgt_module_load((yyvsp[0].string), FALSE); }
#line 2551 "programs/winedbg/dbg.tab.c"
    break;

  case 150: /* maintenance_command: tMAINTENANCE '*' tMODULE tSTRING  */
#line 298 "programs/winedbg/dbg.y"
                                       { tgt_module_load((yyvsp[0].string), TRUE); }
#line 2557 "programs/winedbg/dbg.tab.c"
    break;

  case 151: /* noprocess_state: tNOPROCESS  */
#line 302 "programs/winedbg/dbg.y"
                                 {}
#line 2563 "programs/winedbg/dbg.tab.c"
    break;

  case 152: /* noprocess_state: tNOPROCESS tBACKTRACE tALL  */
#line 303 "programs/winedbg/dbg.y"
                                 { stack_backtrace(-1); }
#line 2569 "programs/winedbg/dbg.tab.c"
    break;

  case 153: /* noprocess_state: tNOPROCESS tSTRING  */
#line 304 "programs/winedbg/dbg.y"
                                 { dbg_printf("No process loaded, cannot execute '%s'\n", (yyvsp[0].string)); }
#line 2575 "programs/winedbg/dbg.tab.c"
    break;

  case 154: /* type_expr: tCHAR  */
#line 308 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_char; }
#line 2581 "programs/winedbg/dbg.tab.c"
    break;

  case 155: /* type_expr: tINT  */
#line 309 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_int; }
#line 2587 "programs/winedbg/dbg.tab.c"
    break;

  case 156: /* type_expr: tLONG tINT  */
#line 310 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_long_int; }
#line 2593 "programs/winedbg/dbg.tab.c"
    break;

  case 157: /* type_expr: tLONG  */
#line 311 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_long_int; }
#line 2599 "programs/winedbg/dbg.tab.c"
    break;

  case 158: /* type_expr: tUNSIGNED tINT  */
#line 312 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_int; }
#line 2605 "programs/winedbg/dbg.tab.c"
    break;

  case 159: /* type_expr: tUNSIGNED  */
#line 313 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_int; }
#line 2611 "programs/winedbg/dbg.tab.c"
    break;

  case 160: /* type_expr: tLONG tUNSIGNED tINT  */
#line 314 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_long_int; }
#line 2617 "programs/winedbg/dbg.tab.c"
    break;

  case 161: /* type_expr: tLONG tUNSIGNED  */
#line 315 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_long_int; }
#line 2623 "programs/winedbg/dbg.tab.c"
    break;

  case 162: /* type_expr: tSHORT tINT  */
#line 316 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_short_int; }
#line 2629 "programs/winedbg/dbg.tab.c"
    break;

  case 163: /* type_expr: tSHORT  */
#line 317 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_short_int; }
#line 2635 "programs/winedbg/dbg.tab.c"
    break;

  case 164: /* type_expr: tSHORT tUNSIGNED tINT  */
#line 318 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_short_int; }
#line 2641 "programs/winedbg/dbg.tab.c"
    break;

  case 165: /* type_expr: tSHORT tUNSIGNED  */
#line 319 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_short_int; }
#line 2647 "programs/winedbg/dbg.tab.c"
    break;

  case 166: /* type_expr: tSIGNED tCHAR  */
#line 320 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_char_int; }
#line 2653 "programs/winedbg/dbg.tab.c"
    break;

  case 167: /* type_expr: tUNSIGNED tCHAR  */
#line 321 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_char_int; }
#line 2659 "programs/winedbg/dbg.tab.c"
    break;

  case 168: /* type_expr: tLONG tLONG tUNSIGNED tINT  */
#line 322 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_longlong_int; }
#line 2665 "programs/winedbg/dbg.tab.c"
    break;

  case 169: /* type_expr: tLONG tLONG tUNSIGNED  */
#line 323 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_unsigned_longlong_int; }
#line 2671 "programs/winedbg/dbg.tab.c"
    break;

  case 170: /* type_expr: tLONG tLONG tINT  */
#line 324 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_longlong_int; }
#line 2677 "programs/winedbg/dbg.tab.c"
    break;

  case 171: /* type_expr: tLONG tLONG  */
#line 325 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_signed_longlong_int; }
#line 2683 "programs/winedbg/dbg.tab.c"
    break;

  case 172: /* type_expr: tFLOAT  */
#line 326 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_short_real; }
#line 2689 "programs/winedbg/dbg.tab.c"
    break;

  case 173: /* type_expr: tDOUBLE  */
#line 327 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_real; }
#line 2695 "programs/winedbg/dbg.tab.c"
    break;

  case 174: /* type_expr: tLONG tDOUBLE  */
#line 328 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_type_id; (yyval.type).deref_count = 0; (yyval.type).u.type.module = 0; (yyval.type).u.type.id = dbg_itype_long_real; }
#line 2701 "programs/winedbg/dbg.tab.c"
    break;

  case 175: /* type_expr: type_expr '*'  */
#line 329 "programs/winedbg/dbg.y"
                                { (yyval.type) = (yyvsp[-1].type); (yyval.type).deref_count++; }
#line 2707 "programs/winedbg/dbg.tab.c"
    break;

  case 176: /* type_expr: tCLASS identifier  */
#line 330 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_udt_class; (yyval.type).deref_count = 0; (yyval.type).u.name = (yyvsp[0].string); }
#line 2713 "programs/winedbg/dbg.tab.c"
    break;

  case 177: /* type_expr: tSTRUCT identifier  */
#line 331 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_udt_struct; (yyval.type).deref_count = 0; (yyval.type).u.name = (yyvsp[0].string); }
#line 2719 "programs/winedbg/dbg.tab.c"
    break;

  case 178: /* type_expr: tUNION identifier  */
#line 332 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_udt_union; (yyval.type).deref_count = 0; (yyval.type).u.name = (yyvsp[0].string); }
#line 2725 "programs/winedbg/dbg.tab.c"
    break;

  case 179: /* type_expr: tENUM identifier  */
#line 333 "programs/winedbg/dbg.y"
                                { (yyval.type).type = type_expr_enumeration; (yyval.type).deref_count = 0; (yyval.type).u.name = (yyvsp[0].string); }
#line 2731 "programs/winedbg/dbg.tab.c"
    break;

  case 180: /* expr_lvalue: expr  */
#line 337 "programs/winedbg/dbg.y"
                                { (yyval.lvalue) = expr_eval((yyvsp[0].expression)); }
#line 2737 "programs/winedbg/dbg.tab.c"
    break;

  case 181: /* expr_rvalue: expr_lvalue  */
#line 341 "programs/winedbg/dbg.y"
                                { (yyval.integer) = types_extract_as_integer(&(yyvsp[0].lvalue)); }
#line 2743 "programs/winedbg/dbg.tab.c"
    break;

  case 182: /* expr: tNUM  */
#line 351 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_sconstant((yyvsp[0].integer)); }
#line 2749 "programs/winedbg/dbg.tab.c"
    break;

  case 183: /* expr: tSTRING  */
#line 352 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_string((yyvsp[0].string)); }
#line 2755 "programs/winedbg/dbg.tab.c"
    break;

  case 184: /* expr: tINTVAR  */
#line 353 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_internal_var((yyvsp[0].string)); }
#line 2761 "programs/winedbg/dbg.tab.c"
    break;

  case 185: /* expr: identifier  */
#line 354 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_symbol((yyvsp[0].string)); }
#line 2767 "programs/winedbg/dbg.tab.c"
    break;

  case 186: /* expr: expr OP_DRF tIDENTIFIER  */
#line 355 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_pstruct((yyvsp[-2].expression), (yyvsp[0].string)); }
#line 2773 "programs/winedbg/dbg.tab.c"
    break;

  case 187: /* expr: expr '.' tIDENTIFIER  */
#line 356 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_struct((yyvsp[-2].expression), (yyvsp[0].string)); }
#line 2779 "programs/winedbg/dbg.tab.c"
    break;

  case 188: /* expr: identifier '(' ')'  */
#line 357 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_func_call((yyvsp[-2].string), 0); }
#line 2785 "programs/winedbg/dbg.tab.c"
    break;

  case 189: /* expr: identifier '(' expr ')'  */
#line 358 "programs/winedbg/dbg.y"
                                { (yyval.expression) = expr_alloc_func_call((yyvsp[-3].string), 1, (yyvsp[-1].expression)); }
#line 2791 "programs/winedbg/dbg.tab.c"
    break;

  case 190: /* expr: identifier '(' expr ',' expr ')'  */
#line 359 "programs/winedbg/dbg.y"
                                       { (yyval.expression) = expr_alloc_func_call((yyvsp[-5].string), 2, (yyvsp[-3].expression), (yyvsp[-1].expression)); }
#line 2797 "programs/winedbg/dbg.tab.c"
    break;

  case 191: /* expr: identifier '(' expr ',' expr ',' expr ')'  */
#line 360 "programs/winedbg/dbg.y"
                                                { (yyval.expression) = expr_alloc_func_call((yyvsp[-7].string), 3, (yyvsp[-5].expression), (yyvsp[-3].expression), (yyvsp[-1].expression)); }
#line 2803 "programs/winedbg/dbg.tab.c"
    break;

  case 192: /* expr: identifier '(' expr ',' expr ',' expr ',' expr ')'  */
#line 361 "programs/winedbg/dbg.y"
                                                         { (yyval.expression) = expr_alloc_func_call((yyvsp[-9].string), 4, (yyvsp[-7].expression), (yyvsp[-5].expression), (yyvsp[-3].expression), (yyvsp[-1].expression)); }
#line 2809 "programs/winedbg/dbg.tab.c"
    break;

  case 193: /* expr: identifier '(' expr ',' expr ',' expr ',' expr ',' expr ')'  */
#line 362 "programs/winedbg/dbg.y"
                                                                  { (yyval.expression) = expr_alloc_func_call((yyvsp[-11].string), 5, (yyvsp[-9].expression), (yyvsp[-7].expression), (yyvsp[-5].expression), (yyvsp[-3].expression), (yyvsp[-1].expression)); }
#line 2815 "programs/winedbg/dbg.tab.c"
    break;

  case 194: /* expr: expr '[' expr ']'  */
#line 363 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_ARR, (yyvsp[-3].expression), (yyvsp[-1].expression)); }
#line 2821 "programs/winedbg/dbg.tab.c"
    break;

  case 195: /* expr: expr ':' expr  */
#line 364 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_SEG, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2827 "programs/winedbg/dbg.tab.c"
    break;

  case 196: /* expr: expr OP_LOR expr  */
#line 365 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_LOR, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2833 "programs/winedbg/dbg.tab.c"
    break;

  case 197: /* expr: expr OP_LAND expr  */
#line 366 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_LAND, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2839 "programs/winedbg/dbg.tab.c"
    break;

  case 198: /* expr: expr '|' expr  */
#line 367 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_OR, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2845 "programs/winedbg/dbg.tab.c"
    break;

  case 199: /* expr: expr '&' expr  */
#line 368 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_AND, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2851 "programs/winedbg/dbg.tab.c"
    break;

  case 200: /* expr: expr '^' expr  */
#line 369 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_XOR, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2857 "programs/winedbg/dbg.tab.c"
    break;

  case 201: /* expr: expr OP_EQ expr  */
#line 370 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_EQ, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2863 "programs/winedbg/dbg.tab.c"
    break;

  case 202: /* expr: expr '>' expr  */
#line 371 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_GT, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2869 "programs/winedbg/dbg.tab.c"
    break;

  case 203: /* expr: expr '<' expr  */
#line 372 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_LT, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2875 "programs/winedbg/dbg.tab.c"
    break;

  case 204: /* expr: expr OP_GE expr  */
#line 373 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_GE, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2881 "programs/winedbg/dbg.tab.c"
    break;

  case 205: /* expr: expr OP_LE expr  */
#line 374 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_LE, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2887 "programs/winedbg/dbg.tab.c"
    break;

  case 206: /* expr: expr OP_NE expr  */
#line 375 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_NE, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2893 "programs/winedbg/dbg.tab.c"
    break;

  case 207: /* expr: expr OP_SHL expr  */
#line 376 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_SHL, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2899 "programs/winedbg/dbg.tab.c"
    break;

  case 208: /* expr: expr OP_SHR expr  */
#line 377 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_SHR, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2905 "programs/winedbg/dbg.tab.c"
    break;

  case 209: /* expr: expr '+' expr  */
#line 378 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_ADD, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2911 "programs/winedbg/dbg.tab.c"
    break;

  case 210: /* expr: expr '-' expr  */
#line 379 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_SUB, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2917 "programs/winedbg/dbg.tab.c"
    break;

  case 211: /* expr: expr '*' expr  */
#line 380 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_MUL, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2923 "programs/winedbg/dbg.tab.c"
    break;

  case 212: /* expr: expr '/' expr  */
#line 381 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_DIV, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2929 "programs/winedbg/dbg.tab.c"
    break;

  case 213: /* expr: expr '%' expr  */
#line 382 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_REM, (yyvsp[-2].expression), (yyvsp[0].expression)); }
#line 2935 "programs/winedbg/dbg.tab.c"
    break;

  case 214: /* expr: '-' expr  */
#line 383 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_unary_op(EXP_OP_NEG, (yyvsp[0].expression)); }
#line 2941 "programs/winedbg/dbg.tab.c"
    break;

  case 215: /* expr: '+' expr  */
#line 384 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = (yyvsp[0].expression); }
#line 2947 "programs/winedbg/dbg.tab.c"
    break;

  case 216: /* expr: '!' expr  */
#line 385 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_unary_op(EXP_OP_NOT, (yyvsp[0].expression)); }
#line 2953 "programs/winedbg/dbg.tab.c"
    break;

  case 217: /* expr: '~' expr  */
#line 386 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_unary_op(EXP_OP_LNOT, (yyvsp[0].expression)); }
#line 2959 "programs/winedbg/dbg.tab.c"
    break;

  case 218: /* expr: '(' expr ')'  */
#line 387 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = (yyvsp[-1].expression); }
#line 2965 "programs/winedbg/dbg.tab.c"
    break;

  case 219: /* expr: '*' expr  */
#line 388 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_unary_op(EXP_OP_DEREF, (yyvsp[0].expression)); }
#line 2971 "programs/winedbg/dbg.tab.c"
    break;

  case 220: /* expr: '&' expr  */
#line 389 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_unary_op(EXP_OP_ADDR, (yyvsp[0].expression)); }
#line 2977 "programs/winedbg/dbg.tab.c"
    break;

  case 221: /* expr: '(' type_expr ')' expr  */
#line 390 "programs/winedbg/dbg.y"
                                            { (yyval.expression) = expr_alloc_typecast(&(yyvsp[-2].type), (yyvsp[0].expression)); }
#line 2983 "programs/winedbg/dbg.tab.c"
    break;

  case 222: /* lvalue_addr: lvalue  */
#line 398 "programs/winedbg/dbg.y"
                                 { (yyval.lvalue) = expr_eval((yyvsp[0].expression)); }
#line 2989 "programs/winedbg/dbg.tab.c"
    break;

  case 223: /* lvalue: tNUM  */
#line 402 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_sconstant((yyvsp[0].integer)); }
#line 2995 "programs/winedbg/dbg.tab.c"
    break;

  case 224: /* lvalue: tINTVAR  */
#line 403 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_internal_var((yyvsp[0].string)); }
#line 3001 "programs/winedbg/dbg.tab.c"
    break;

  case 225: /* lvalue: identifier  */
#line 404 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_symbol((yyvsp[0].string)); }
#line 3007 "programs/winedbg/dbg.tab.c"
    break;

  case 226: /* lvalue: lvalue OP_DRF tIDENTIFIER  */
#line 405 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_pstruct((yyvsp[-2].expression), (yyvsp[0].string)); }
#line 3013 "programs/winedbg/dbg.tab.c"
    break;

  case 227: /* lvalue: lvalue '.' tIDENTIFIER  */
#line 406 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_struct((yyvsp[-2].expression), (yyvsp[0].string)); }
#line 3019 "programs/winedbg/dbg.tab.c"
    break;

  case 228: /* lvalue: lvalue '[' expr ']'  */
#line 407 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_binary_op(EXP_OP_ARR, (yyvsp[-3].expression), (yyvsp[-1].expression)); }
#line 3025 "programs/winedbg/dbg.tab.c"
    break;

  case 229: /* lvalue: '*' expr  */
#line 408 "programs/winedbg/dbg.y"
                                 { (yyval.expression) = expr_alloc_unary_op(EXP_OP_FORCE_DEREF, (yyvsp[0].expression)); }
#line 3031 "programs/winedbg/dbg.tab.c"
    break;


#line 3035 "programs/winedbg/dbg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == DBG_EMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= DBG_EOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == DBG_EOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = DBG_EMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != DBG_EMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 411 "programs/winedbg/dbg.y"


static LONG WINAPI wine_dbg_cmd(EXCEPTION_POINTERS *eptr)
{
    switch (eptr->ExceptionRecord->ExceptionCode)
    {
    case DEBUG_STATUS_INTERNAL_ERROR:
        dbg_printf("\nWineDbg internal error\n");
        break;
    case DEBUG_STATUS_NO_SYMBOL:
        dbg_printf("\nUndefined symbol\n");
        break;
    case DEBUG_STATUS_DIV_BY_ZERO:
        dbg_printf("\nDivision by zero\n");
        break;
    case DEBUG_STATUS_BAD_TYPE:
        dbg_printf("\nNo type or type mismatch\n");
        break;
    case DEBUG_STATUS_NO_FIELD:
        dbg_printf("\nNo such field in structure or union\n");
        break;
    case DEBUG_STATUS_CANT_DEREF:
        dbg_printf("\nDereference failed (not a pointer, or out of array bounds)\n");
        break;
    case DEBUG_STATUS_ABORT:
        break;
    case DEBUG_STATUS_NOT_AN_INTEGER:
        dbg_printf("\nNeeding an integral value\n");
        break;
    case CONTROL_C_EXIT:
        /* this is generally sent by a ctrl-c when we run winedbg outside of wineconsole */
        /* stop the debuggee, and continue debugger execution, we will be reentered by the
         * debug events generated by stopping
         */
        dbg_interrupt_debuggee();
        return EXCEPTION_CONTINUE_EXECUTION;
    default:
        dbg_printf("\nException %lx\n", eptr->ExceptionRecord->ExceptionCode);
        break;
    }

    return EXCEPTION_EXECUTE_HANDLER;
}

struct parser_context
{
    const char* filename;
    HANDLE input;
    HANDLE output;
    unsigned line_no;
    char*  last_line;
    size_t last_line_idx;
};

static struct parser_context dbg_parser = {NULL, INVALID_HANDLE_VALUE, INVALID_HANDLE_VALUE, 0, NULL, 0};

static int input_fetch_entire_line(const char* pfx, char** line)
{
    char*       buffer;
    char        ch;
    DWORD	nread;
    size_t      len, alloc;

    /* as of today, console handles can be file handles... so better use file APIs rather than
     * console's
     */
    WriteFile(dbg_parser.output, pfx, strlen(pfx), &nread, NULL);

    buffer = HeapAlloc(GetProcessHeap(), 0, alloc = 16);
    assert(buffer != NULL);

    dbg_parser.line_no++;
    len = 0;
    do
    {
        if (!ReadFile(dbg_parser.input, &ch, 1, &nread, NULL) || nread == 0)
        {
            HeapFree(GetProcessHeap(), 0, buffer);
            return -1;
        }

        if (len + 2 > alloc)
        {
            while (len + 2 > alloc) alloc *= 2;
            buffer = dbg_heap_realloc(buffer, alloc);
        }
        buffer[len++] = ch;
    }
    while (ch != '\n');
    buffer[len] = '\0';

    *line = buffer;
    return len;
}

size_t input_lex_read_buffer(char* buf, int size)
{
    int len;

    /* try first to fetch the remaining of an existing line */
    if (dbg_parser.last_line_idx == 0)
    {
        char* tmp = NULL;
        /* no remaining chars to be read from last line, grab a brand new line up to '\n' */
        lexeme_flush();
        len = input_fetch_entire_line("Wine-dbg>", &tmp);
        if (len < 0) return 0;  /* eof */

        /* remove carriage return in newline */
        if (len >= 2 && tmp[len - 2] == '\r')
        {
            tmp[len - 2] = '\n';
            tmp[len - 1] = '\0';
            len--;
        }

        /* recall last command when empty input buffer and not parsing a file */
        if (dbg_parser.last_line && (len == 0 || (len == 1 && tmp[0] == '\n')) &&
            dbg_parser.output != INVALID_HANDLE_VALUE)
        {
            HeapFree(GetProcessHeap(), 0, tmp);
        }
        else
        {
            HeapFree(GetProcessHeap(), 0, dbg_parser.last_line);
            dbg_parser.last_line = tmp;
        }
    }

    len = min(strlen(dbg_parser.last_line + dbg_parser.last_line_idx), size - 1);
    memcpy(buf, dbg_parser.last_line + dbg_parser.last_line_idx, len);
    buf[len] = '\0';
    if ((dbg_parser.last_line_idx += len) >= strlen(dbg_parser.last_line))
        dbg_parser.last_line_idx = 0;
    return len;
}

int input_read_line(const char* pfx, char* buf, int size)
{
    char*       line = NULL;

    int len = input_fetch_entire_line(pfx, &line);
    if (len < 0) return 0;
    /* remove trailing \n and \r */
    while (len > 0 && (line[len - 1] == '\n' || line[len - 1] == '\r')) len--;
    len = min(size - 1, len);
    memcpy(buf, line, len);
    buf[len] = '\0';
    HeapFree(GetProcessHeap(), 0, line);
    return 1;
}

/***********************************************************************
 *           parser_handle
 *
 * Debugger command line parser
 */
void	parser_handle(const char* filename, HANDLE input)
{
    BOOL ret_ok;
    struct parser_context prev = dbg_parser;

    ret_ok = FALSE;

    if (input != INVALID_HANDLE_VALUE)
    {
        dbg_parser.output = INVALID_HANDLE_VALUE;
        dbg_parser.input  = input;
    }
    else
    {
        dbg_parser.output = GetStdHandle(STD_OUTPUT_HANDLE);
        dbg_parser.input  = GetStdHandle(STD_INPUT_HANDLE);
    }
    dbg_parser.line_no = 0;
    dbg_parser.filename = filename;
    dbg_parser.last_line = NULL;
    dbg_parser.last_line_idx = 0;
    do
    {
       __TRY
       {
	  ret_ok = TRUE;
	  dbg_parse();
       }
       __EXCEPT(wine_dbg_cmd)
       {
	  ret_ok = FALSE;
       }
       __ENDTRY;
       lexeme_flush();
    } while (!ret_ok);

    dbg_parser = prev;
}

static void parser(const char* filename)
{
    HANDLE h = CreateFileA(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0L, 0);
    if (h != INVALID_HANDLE_VALUE)
    {
        parser_handle(filename, h);
        CloseHandle(h);
    }
}

static int dbg_error(const char* s)
{
    if (dbg_parser.filename)
        dbg_printf("%s:%d:", dbg_parser.filename, dbg_parser.line_no);
    dbg_printf("%s\n", s);
    return 0;
}

HANDLE WINAPIV parser_generate_command_file(const char* pmt, ...)
{
    HANDLE      hFile;
    char        path[MAX_PATH], file[MAX_PATH];
    DWORD       w;
    const char* p;

    GetTempPathA(sizeof(path), path);
    GetTempFileNameA(path, "WD", 0, file);
    hFile = CreateFileA(file, GENERIC_READ|GENERIC_WRITE|DELETE, FILE_SHARE_DELETE, 
                        NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_DELETE_ON_CLOSE, 0);
    if (hFile != INVALID_HANDLE_VALUE)
    {
        va_list ap;

        WriteFile(hFile, pmt, strlen(pmt), &w, 0);
        va_start(ap, pmt);
        while ((p = va_arg(ap, const char*)) != NULL)
        {
            WriteFile(hFile, "\n", 1, &w, 0);
            WriteFile(hFile, p, strlen(p), &w, 0);
        }
        va_end(ap);
        WriteFile(hFile, "\nquit\n", 6, &w, 0);
        SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
    }
    return hFile;
}
